using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.AI.Entity
 {
    [TypeScript]
    [Table("dms_folder_map")]
    public class DmsFolderMapEntity : EntityBase<DmsFolderMapEntityKey>
    {

    public DmsFolderMapEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Column("folder_name_parent")]
    public string FolderNameParent  { get; set; }
    [Column("folder_name_son")]
    public string FolderNameSon  { get; set; }
    [Column("orderby")]
    public int Orderby  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string FOLDER_NAME_PARENT = "FolderNameParent";
    public const string FOLDER_NAME_SON = "FolderNameSon";
    public const string ORDERBY = "Orderby";

    public const string DB_NAME_DMS_FOLDER_MAP = "dms_folder_map";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,folder_name_parent,folder_name_son,orderby";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_FOLDER_NAME_PARENT = "folder_name_parent";
    public const string DB_FOLDER_NAME_SON = "folder_name_son";
    public const string DB_ORDERBY = "orderby";


    public static DmsFolderMapEntity GetInstance()
    {
        return new DmsFolderMapEntity();
    }

    public virtual void CopyFrom(DmsFolderMapEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(DmsFolderMapEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.FolderNameParent =  source.FolderNameParent;
        this.FolderNameSon =  source.FolderNameSon;
        this.Orderby =  source.Orderby;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_DMS_FOLDER_MAP}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_DMS_FOLDER_MAP}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_FOLDER_NAME_PARENT ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_DMS_FOLDER_MAP}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public DmsFolderMapEntity Clone()
    {
        DmsFolderMapEntity result = new DmsFolderMapEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
